<?php
/*
This script will reclaim ownership of the config files, which is usually required if you copy the config files to the server via FTP.  It's a UNIX security group thing.

Don't forget to delete this file when you are done.
*/


function web_line($in) {
	echo $in."<br />\n";
}

function file_replace($in, $out) {
	if (file_exists ($out)) {
		if (!unlink ($out)) {
			return FALSE;
		}
	}
	return (rename ($in, $out)) ? TRUE : FALSE;
}

function config_replace($in) {
	// DANGER:
	// Temp file MUST end in '.php' to prevent security issues!
	$temp = substr ($in, 0, -4).'_old.php';

	// Trash old files
	if (!($cfg = file_get_contents ($in))) {
		web_line ('Failed to read '.$in);
		return FALSE;
	}

	// Rename.
	if (! (file_replace($in, $temp))) {
		web_line ('Cannot delete temp file '.$temp);
		return FALSE;
	}

	// Write, or try to recover
	// file_put_contents() is PHP5 only
	$fp = fopen ($in, 'wb');
	if ($fp) {
		fwrite ($fp, $cfg);
		fclose ($fp);
	} else {
		web_line ('Cannot write new '.$in);
		file_replace($temp, $in);
		return FALSE;
	}

	// Cleanup
	// Try to avoid Windows caching issue
	@unlink ($temp);
	return TRUE;
}


// =====
// Trash old files
//
$status = config_replace('config.php');
$status2 = config_replace('dbconn.php');

if ($status && $status2) {
	web_line ("<br />\nConfig files should now be writable.");
} else {
	web_line ("<br />\n"."Failed!  If you're using Windows, wait 15 seconds and run this file again.<br />\nIf using UNIX/Linux, check that there are no temp files and the original config files are named properly.");
}

exit();

?>